import 'package:args/command_runner.dart';
import 'package:report/parser/parse.dart';

class CreateCommand extends Command {
  CreateCommand() {
    argParser.addOption('root_path');
    argParser.addOption('report_path');
    argParser.addOption('isLogger');
  }
  @override
  final name = 'report';

  @override
  final description = 'add report';

  @override
  Future<void> run() async {
    assert(
      argResults['root_path'] != null && argResults['report_path'] != null,
    );
    isLogger = argResults['isLogger'] != null ? true : false;
    await runAnalyze(
      rootPath: argResults['root_path'],
      reportPath: argResults['report_path'],
    );
  }
}

void main(List<String> arguments) {
  CommandRunner('report', 'report Tools.')
    ..addCommand(CreateCommand())
    ..run(arguments);
}
