import 'dart:convert';
import 'dart:io';

import 'package:path/path.dart' as p;
import 'package:report/parser/parse.dart';

Future<List<String>> packagePath(String rootPath) async {
  if (isTest) {
    return testPath();
  }
  Directory dir = Directory(p.join(
    rootPath,
    'package',
  ));

  final List<String> paths = dir
      .listSync(recursive: true)
      .where((element) => element.path.endsWith('.dart') && element.path.contains('lib'))
      .map((e) => p.join(rootPath, e.path))
      .toList();
  return paths;
}

List<String> testPath() {
  return [
    '/Users/dansun/Desktop/edu/ai_teacher_middle_school/src/package/bloc/homework_check/lib/src/homework_check/homework_detail/widgets/student_list_analyze.dart'
  ];
}

Future<Map<String, dynamic>> reportJson(String path) async {
  if (path == null || path.isEmpty) {
    return null;
  }
  File file = File(path);
  if (!(await file.exists())) {
    return null;
  }
  Map<String, dynamic> map = Map<String, dynamic>.from(jsonDecode(await file.readAsString()));
  return map;
}
