import 'package:_fe_analyzer_shared/src/scanner/token.dart';

class Constructor {
  List<Property> properties;
  Token constructorBegin;

  @override
  String toString() {
    return 'Constructor{properties: $properties, constructorBegin: $constructorBegin}';
  }
}

class Property {
  PropertyPosition uuidPosition;
  PropertyPosition namePosition;

  Property();

  @override
  String toString() {
    return 'Property{uuidPosition: $uuidPosition, namePosition: $namePosition}';
  }
}

class PropertyPosition {
  final Token beginToken;
  final Token endToken;

  PropertyPosition(this.beginToken, this.endToken);

  @override
  String toString() {
    return 'PropertyPosition{beginToken: $beginToken beginToken charOffset ${beginToken.charOffset} beginToken charEnd ${beginToken.charEnd}, endToken: $endToken} endToken charOffset ${endToken.charOffset} endToken charEnd ${endToken.charEnd}';
  }
}
