import 'package:report/parser/property_path.dart';
import 'package:report/parser/report.dart';

import 'logger.dart';

void statisticsData(List<Constructor> list, ReportData reportData) {
  ///统计数据
  if (list.isNotEmpty) {
    int finishCount = 0;
    int sumCount = 0;

    List uuidList = [];

    list.forEach((element) {
      sumCount += element.properties.length;
      element.properties.forEach((property) {
        if (property.namePosition != null && property.namePosition.endToken.lexeme.length > 3 && property.uuidPosition != null) {
          finishCount++;
        }
        String uuid = property.uuidPosition.endToken.lexeme.substring(1, property.uuidPosition.endToken.lexeme.length - 1);
        uuidList.add(uuid);
      });
    });

    logInfo('已经完成 ：${finishCount} 总数 :${sumCount} ${(finishCount / sumCount).toStringAsFixed(2)}');
    List unMatch = [];
    reportData.reportMap.keys.forEach((element) {
      if (!uuidList.any((element2) => element2 == element)) {
        unMatch.add(element);
      }
    });
    logInfo('未匹配 ：${unMatch.toString()} ');
  }
}
